<?

namespace Avos\Admin;
error_reporting(E_ALL);
function processRequest()
{
	\Avos\Database\disableCache();

	\Avos\Admin\route(array(
		array('login',								'login'),
		array('logout',								'logout'),
		array('',									'summary'),
		array('summary',							'summary'),
		array('search',								'search'),
		array('webcams',							'webcams'),
		array('categories',							'categories'),
		array('test-categories',					'categoriesTester'),
		array('videos',								'videos'),
		array('videos-edit',						'videosEdit'),
		array('photos',								'photos'),
		array('photos-edit',						'photosEdit'),
		array('blog',								'blogCreate'),
		array('blog-edit',							'blogEdit'),
		array('blog-list',							'blogList'),
		array('tags',								'tags'),
		array('meta-generator',						'metaGenerator'),
		array('meta-generator/meta.csv',			'metaGenerator'),
		array('meta-generator/meta.ini',			'metaGenerator'),
		array('add-promote-websites',				'sitesCreate'),
		array('sites-list',							'sitesList'),
		array('sites-edit',							'sitesEdit'),
		array('siteStats',							'siteStats'),
		array('logs',								'logs')
	));
}






//////////////////////////////////////////////////////////////////////////////////////

#siteStats see what site is best on cb
function siteStats()
{
    global $_AVOS;

    if (!isset($_SESSION['loggedin'])) {
        return array('redirect' => '?page=login');
    }

    

    return array(
        
        'template' => 'siteStats.php',
    );
}


////////////////////////////////////////////////////////////////////////////////////////////
function summary()
{
	if (!isset($_SESSION['loggedin'])) {
		return array('redirect' => '?page=login');
	}

	global $_AVOS;
	$counts = array();
	$counts['webcams'] = \getWebcamsCounts();

	$tmp = \Avos\Database\queryList("select count(*) from videos");
	$counts['videos'] = $tmp[0];

	$tmp = \Avos\Database\queryList("select count(*) from photos");
	$counts['photos'] = $tmp[0];

	$tmp = \Avos\Database\queryList("select count(*) from ArticleBlogPosts;");
	$counts['blogs'] = $tmp[0];

	$tmp = \Avos\Database\queryList("select count(*) from promote;");
	$counts['promote'] = $tmp[0];


	$sites = \Avos\Database\queryAssoc("select site,max(updatedon) as updatedon from webcams group by site order by site");

	foreach ($sites as $i => $s) {
		$sites[$i]['name'] = \Avos\Scaffold\expandSiteName($s['site']);
		$sites[$i]['updatedon'] = date('d M Y H:i:s', $s['updatedon']);
	}

	$totals = array('total' => 0, 'online' => 0, 'offline' => 0, 'archived' => 0, 'hidden' => 0);

	foreach ($counts['webcams']['sites'] as $name => $s) {
		$totals['total'] += isset($s['offline']) ? $s['total'] : 0;
		$totals['online'] += isset($s['online']) ? $s['online'] : 0;
		$totals['offline'] += isset($s['offline']) ? $s['offline'] : 0;
		$totals['archived'] += isset($s['offline']) ? $s['archived'] : 0;
	}

	if (getConfig('site', 'adminSummarySkipArchive', 0)) {
		$totals['hidden'] = '?';
	}
	else {
		$tmp = \Avos\Database\queryList("select count(*) from webcamsArchive where updatedon=0");
		$totals['hidden'] = $tmp[0];
	}

	$tmp = \Avos\Database\queryList("select count(*) from webcams");
	$totals['liveTable'] = $tmp[0];

////////////////////////////////////////////////////////////////////////////////////////////
	//
	// videos summary admin page
	//

	$videos = \Avos\Database\queryAssoc("select processed, publishedon>0 as published,(description!='' and tags!='') as complete, count(*) as num from videos group by processed,complete,publishedon>0");

	foreach ($videos as $i => $v) {
		$videos[$i]['processed'] = $v['processed'] == 1 ? 'Yes' : 'No';
		$videos[$i]['complete'] = $v['complete'] == 1 ? 'Yes' : 'No';
		$videos[$i]['published'] = $v['published'] == 1 ? 'Yes' : 'No';
	}

////////////////////////////////////////////////////////////////////////////////////////////
	//
	// photos summary admin page
	//

	$photos = \Avos\Database\queryAssoc("select publishedon>0 as published,count(*) as num from photos group by publishedon>0");

	foreach ($photos as $i => $v) {
		$photos[$i]['published'] = $v['published'] == 1 ? 'Yes' : 'No';
	}

	return array(
		'args' => array(
			'counts' => $counts,
			'totals' => $totals,
			'sites' => $sites,
			'videos' => $videos,
			'photos' => $photos
		),
		'template' => 'summary.php'
	);
}

////////////////////////////////////////////////////////////////////////////////////////////
	//
	// search 
	//
function search()
{
	if (!isset($_SESSION['loggedin'])) {
	return array('redirect' => '?page=login');
}
	

	switch ($_GET['type']) {
		case 'w':
		case 'wa':
			return webcams();
			break;
		case 'v':
			return videos();
			break;
		case 't':
			return tags();
			break;
		default:
			return array('template' => '404.php');
	}
}

////////////////////////////////////////////////////////////////////////////////////////////
	//
	// webcams summary admin page
	//

function webcams()
{
	if (!isset($_SESSION['loggedin'])) {
		return array('redirect' => '?page=login');
	}

    $webcams = array();

    if (!empty($_GET['hide'])) {
        \Avos\Database\query("UPDATE webcams SET updatedOn=0 WHERE id=:hide", $_GET);
        \Avos\Database\query("UPDATE webcamsArchive SET updatedOn=0 WHERE id=:hide", $_GET);
        \Avos\Cron\archive_models($_GET['hide']);
    }
    elseif (!empty($_GET['unhide'])) {
        \Avos\Database\query("UPDATE webcams SET updatedOn=UNIX_TIMESTAMP() WHERE id=:unhide", $_GET);
        \Avos\Database\query("UPDATE webcamsArchive SET updatedOn=UNIX_TIMESTAMP() WHERE id=:unhide", $_GET);
        list($m) = \Avos\Database\queryAssoc("SELECT * FROM webcamsArchive WHERE id=:unhide", $_GET);
        \Avos\Cron\unarchive_model($m);
    }

    if (!empty($_GET['kw']) && strlen($_GET['kw']) > 2) {
        $ext = $_GET['type'] == 'wa' ? 'Archive': '';
        $limit = (int)isset($_GET['limit']) ? $_GET['limit'] : 100;
        $kw = mysqli_real_escape_string(\Avos\Database\dbh(), $_GET['kw']);
        $webcams  = \Avos\Database\queryAssoc("SELECT * FROM webcams$ext WHERE nickname LIKE '%$kw%' ORDER BY nickname LIMIT $limit");
    }

	return array(
		'args' => array(
			'webcams' => $webcams
		),
		'template' => 'webcams.php'
	);
}

////////////////////////////////////////////////////////////////////////////////////////////

function categories()
{
	if (!isset($_SESSION['loggedin'])) {
		return array('redirect' => '?page=login');
	}

	$categories = \Avos\Database\queryAssoc("SELECT name, COUNT(*) AS num FROM webcamsCategories GROUP BY name");
	$tags = \Avos\Database\queryAssoc("SELECT name, COUNT(*) AS num FROM webcamsTags GROUP BY name");

	return array(
		'args' => array(
			'categories' => $categories,
			'tags' => $tags
		),
		'template' => 'webcamsCategories.php'
	);
}

////////////////////////////////////////////////////////////////////////////////////////////

function categoriesTester()
{
	global $_AVOS;

	if (!isset($_SESSION['loggedin'])) {
		return array('redirect' => '?page=login');
	}

    $loaded = '';
    $_AVOS['page']['type'] = 'webcams';

	if (count($_POST) > 0) {

		//
		// use main form data and construct the avos filter
		//

		if (isset($_POST['selectSearch'])) {

			$query = "";

            if (!empty($_POST['ageFrom']) && !empty($_POST['ageTo'])) {
                $query .= "age=" . ($_POST['ageFrom'] + 1) . '..' . ($_POST['ageTo'] - 1);
            }
            elseif (!empty($_POST['ageFrom'])) $query .= "age>" . $_POST['ageFrom'] . '&';
            elseif (!empty($_POST['ageTo'])) $query .= "age<" . $_POST['ageTo'] . '&';

			if (!empty($_POST['tags'])) {
				$tags = $_POST['tags'];
				#$tags = str_replace(' ', '%', $tags);
				$tags = str_replace(',', '%', $tags);
				$tags = preg_replace('!%+!', '%', $tags);
				$query .= "tags=$tags&";
			}

			if (!empty($_POST['status1'])) {
				$is = $_POST['statusIs'];
				$query .= "status=$is" . $_POST['status1'];
				if (!empty($_POST['status2'])) $query .= '|' . $_POST['status2'];
				if (!empty($_POST['status3'])) $query .= '|' . $_POST['status3'];
				$query .= '&';
			}

			if (!empty($_POST['site1'])) {
				$is = $_POST['siteIs'];
				$query .= "site=$is" . $_POST['site1'];
				if (!empty($_POST['site2'])) $query .= '|' . $_POST['site2'];
				if (!empty($_POST['site3'])) $query .= '|' . $_POST['site3'];
				if (!empty($_POST['site4'])) $query .= '|' . $_POST['site4'];
				$query .= '&';
			}

			if (!empty($_POST['gender1'])) {
				$is = $_POST['genderIs'];
				$query .= "gender=$is" . $_POST['gender1'];
				if (!empty($_POST['gender2'])) $query .= '|' . $_POST['gender2'];
				if (!empty($_POST['gender3'])) $query .= '|' . $_POST['gender3'];
				$query .= '&';
            }

            if (!empty($_POST['kw'])) {
                $query .= 'kw=' . $_POST['kw'] . '&';
            }

			$query = rtrim($query, '&');
			$form = $_POST;
		}

		//
		// use avos raw filter and construct the main form data
		//

		elseif (isset($_POST['querySearch']) || isset($_POST['loadCategory'])) {

			if (isset($_POST['loadCategory'])) {
				$cat = $_POST['category'];
				list($type, $name) = explode(':', $cat);
				$cat = \getWebcamsCategory($name, $type);

				if ($cat !== FALSE) {
					$query = $cat['filter'];
					$loaded = "$type:$name";
				}
			}
			else {
				$query = $_POST['query'];
			}

			parse_str($query, $arr);

			$form = array(
				'statusIs' => '',
				'status1' => '',
				'status2' => '',
				'status3' => '',
				'siteIs' => '',
				'site1' => '',
				'site2' => '',
				'site3' => '',
				'site4' => '',
				'genderIs' => '',
				'gender1' => '',
				'gender2' => '',
				'gender3' => '',
				'tags' => '',
				'ageFrom' => '',
				'ageTo' => '',
				'kw' => ''
			);

			if (isset($arr['status'])) {
				$aarr = explode('|', $arr['status']);
				if (preg_match('!^(\!?)(.+)!', $aarr[0], $c)) {
					if (!empty($c[1])) $form['statusIs'] = '!';
					if (!empty($c[2])) $form['status1'] = $c[2];
					if (!empty($aarr[1])) $form['status2'] = $aarr[1];
					if (!empty($aarr[2])) $form['status3'] = $aarr[2];
				}
			}

			if (isset($arr['site'])) {
				$aarr = explode('|', $arr['site']);
				if (preg_match('!^(\!?)(.+)!', $aarr[0], $c)) {
					if (!empty($c[1])) $form['siteIs'] = '!';
					if (!empty($c[2])) $form['site1'] = $c[2];
					if (!empty($aarr[1])) $form['site2'] = $aarr[1];
					if (!empty($aarr[2])) $form['site3'] = $aarr[2];
					if (!empty($aarr[3])) $form['site4'] = $aarr[3];
				}
			}

			if (isset($arr['gender'])) {
				$aarr = explode('|', $arr['gender']);
				if (preg_match('!^(\!?)(.+)!', $aarr[0], $c)) {
					if (!empty($c[1])) $form['genderIs'] = '!';
					if (!empty($c[2])) $form['gender1'] = $c[2];
					if (!empty($aarr[1])) $form['gender2'] = $aarr[1];
					if (!empty($aarr[2])) $form['gender3'] = $aarr[2];
				}
			}

			foreach ($arr as $k => $v) {
				if (preg_match('!age([<>])(\d+)!', $k, $c)) {
					if ($c[1] == '>') $form['ageFrom'] = $c[2];
					elseif ($c[1] == '<') $form['ageTo'] = $c[2];
				}
			}

			if (isset($arr['tags'])) $form['tags'] = $arr['tags'];
		}

		//
		// search how many webcams are online using this filter per site
		//

		$sql = \Avos\Utils\query2sql($query);
		$webcams = \Avos\Database\queryAssoc("SELECT site, COUNT(*) AS num FROM webcams WHERE $sql AND status!='o' GROUP BY site");

		foreach ($webcams as $i => $w) {
			$webcams[$i]['site'] = \Avos\Scaffold\expandSiteName($w['site']);
		}
	}
	else {
		$form = array(
			'statusIs' => '',
			'status1' => '',
			'status2' => '',
			'status3' => '',
			'siteIs' => '',
			'site1' => '',
			'site2' => '',
			'site3' => '',
			'site4' => '',
			'genderIs' => '',
			'gender1' => '',
			'gender2' => '',
			'gender3' => '',
			'tags' => '',
			'ageFrom' => '',
			'ageTo' => '',
			'kw' => ''
		);
	}

	if (!isset($webcams)) {
		$webcams = array();
	}

	#echo "<pre>"; print_r($form); exit;

	$cats = array();

	$q = \listWebcamsCategories();
	foreach ($q as $n) {
		$cats[] = array('name' => $n['category'], 'type' => 'categories');
	}

	$q = \listWebcamsCategories('tags');
	foreach ($q as $n) {
		$cats[] = array('name' => $n['tag'], 'type' => 'tags');
    }

    $catsStats = \Avos\Database\queryAssoc("select c.name, w.gender, count(w.gender) as num from webcamsCategories c, webcams w where c.webcamsId=w.id group by c.name, w.gender order by c.name, w.gender='f' desc, w.gender='m' desc, w.gender='t' desc, w.gender='c' desc");

    $tagsStats = \Avos\Database\queryAssoc("select c.name, w.gender, count(w.gender) as num from webcamsTags c, webcams w where c.webcamsId=w.id group by c.name, w.gender order by c.name, w.gender='f' desc, w.gender='m' desc, w.gender='t' desc, w.gender='c' desc");

    return array(
        'args' => array(
            'query' => isset($query) ? $query : '',
            'form' => $form,
            'webcams' => $webcams,
            'categories' => $cats,
            'loaded' => $loaded,
            'catsStats' => $catsStats,
            'tagsStats' => $tagsStats
        ),
        'template' => 'webcamsCategoriesTester.php'
    );
}

////////////////////////////////////////////////////////////////////////////////////////////

function metaGenerator()
{
	if (!isset($_SESSION['loggedin'])) {
		return array('redirect' => '?page=login');
	}
    global $_AVOS;

    if (!isset($_SESSION['loggedin'])) {
        return array('redirect' => '?page=login');
    }

    if (count($_POST) == 0) {
        return array(
            'args' => array(
            ),
            'template' => 'metaGenerator.php'
        );
    }
    $meta = array();
    $urls = \Avos\Scaffold\getUrlConfig()['urls'];
    $counts = \getWebcamsCounts();
    $cats = $counts['categories'];
	




	//
	// Set element if need to use in meda fieds
	//
	$mysite = $_AVOS['config']['site']['url_meta_site'];

	

    $tags = $counts['tags'];
    $author = array();
    $keywords = array();
    $numKeywords = $_POST['keywords'];
    $category = $_POST['category'];



    mt_srand(microtime(true) * 1000);
    \Avos\Scaffold\readAuthorRules();
    $author = $_AVOS['author'];
    #echo "<pre>";print_r($author);exit;
    #echo implode(',', \Avos\Scaffold\author('category:keywords', [ 'category' => 'anal' ], $author, 10));exit;

    //
    // iterate thru all [urls]
    //

    foreach ($urls as $u) {
        $tmpl = $u[0];
        $type = $u[1];
        $path = $u[2];

        if (!preg_match('!(none|webcams?|videos?|photos?|blogs?|blog?|promote?|promot?|users?|casino?)!', $type)) continue;
        if ($type == 'redirect') continue;

        $path = str_replace(array(':page', ':id', ':siteId', ':title', ':urlTitle', ':nickname', ':kw', ':Title', ':siteNames', ':username' , ':_month', ':_year'), '*', $path);
        $path = preg_replace('!(:_\w+)!', '*', $path);
		
        if ($type == 'videos') {
            $path = str_replace(':tag', '*', $path);
        }
	
		if ($type == 'blogs') {
            $path = str_replace(':Title', '-', $path);
        }
		
		if ($type == 'blog') {
            $path = str_replace(':Title', '-', $path);
        }
		
		if ($type == 'promote') {
            $path = str_replace(':siteNames', '-', $path);
        }
		if ($type == 'promot') {
            $path = str_replace(':siteNames', '-', $path);
        }
		 
		if ($type == 'users') {
            $path = str_replace(':username', '-', $path);
        }

        $path = str_replace('*/*', '*', $path);
        $path = str_replace('.*', '*', $path);

		// add way to add meta for promote page --can do for blog to to get keywords from tags
		$promote = \Avos\Database\queryAssoc("select * from promoteMainDescription");
		$metaVideos = \Avos\Database\queryAssoc("SELECT meta_title, meta_description, meta_keywords FROM videos WHERE meta_title IS NOT NULL");
		$metaPhotos = \Avos\Database\queryAssoc("SELECT meta_title, meta_description, meta_keywords FROM photos WHERE meta_title IS NOT NULL");





////////////////////////////////Take urls from config to equal the $path ///////////////

// Assuming $_AVOS['config']['urls'] is an array containing my URL configurations

$modifiedInputs = [];
foreach ($_AVOS['config']['urls'] as $customName => $input) {
    if (preg_match('/,([^,]*)(,|$)/', $input, $matches)) {
        $capturedValue = trim($matches[1]);

        if (strpos($capturedValue, ':nickname') !== false) {
            $capturedValue = str_replace(':nickname', '*', $capturedValue);
        }

        if (strpos($capturedValue, ':page') !== false) {
            $capturedValue = str_replace(':page', '*', $capturedValue);
        }
		 if ($customName === 'webcamsStatsMonth' && strpos($capturedValue, '/stats/') !== false) {
            $capturedValue = str_replace('/:site/*/stats/:_year/:_month', '/:site/*/stats/*', $capturedValue);
        }

        $capturedValue = rtrim($capturedValue, ' ]');
        $modifiedInput = $capturedValue;
    } else {
        $modifiedInput = '';
    }

    // Check if the key exists before accessing it
    if (isset($modifiedInput)) {
        $modifiedInputs[$customName] = $modifiedInput;
    } else {
        $modifiedInputs[$customName] = '';
    }
}


// Access the modified inputs using custom names like $webcamsVersus, $webcamsCustom, etc.
$webcamsFeed 			= isset($modifiedInputs['webcamsFeed']) ? $modifiedInputs['webcamsFeed'] : '';
$webcamsNickname 		= isset($modifiedInputs['webcamsNickname']) ? $modifiedInputs['webcamsNickname'] : '';
$webcamsCustom		    = isset($modifiedInputs['webcamsCustom']) ? $modifiedInputs['webcamsCustom'] : '';
$webcamsMulti 			= isset($modifiedInputs['webcamsMulti']) ? $modifiedInputs['webcamsMulti'] : '';
$webcamsRandom 			= isset($modifiedInputs['webcamsRandom']) ? $modifiedInputs['webcamsRandom'] : '';
$webcamsDiscover 		= isset($modifiedInputs['webcamsDiscover']) ? $modifiedInputs['webcamsDiscover'] : '';
$webcamsVersusMat	    = isset($modifiedInputs['webcamsVersusMat']) ? $modifiedInputs['webcamsVersusMat'] : '';
$webcamsLiveTv	        = isset($modifiedInputs['webcamsLiveTv']) ? $modifiedInputs['webcamsLiveTv'] : '';
$searchMyPage 		    = isset($modifiedInputs['search']) ? $modifiedInputs['search'] : '';
$country			    = isset($modifiedInputs['country']) ? $modifiedInputs['country'] : '';
$webcamsRoulette 		= isset($modifiedInputs['webcamsRoulette']) ? $modifiedInputs['webcamsRoulette'] : '';
$webcamsTagspage 		= isset($modifiedInputs['webcamsTagspage']) ? $modifiedInputs['webcamsTagspage'] : '';
$webcamsTag 			= isset($modifiedInputs['webcamsTag']) ? $modifiedInputs['webcamsTag'] : '';
$webcamsPrivate		    = isset($modifiedInputs['webcamsPrivate']) ? $modifiedInputs['webcamsPrivate'] : '';
$webcamsBest 			= isset($modifiedInputs['webcamsBest']) ? $modifiedInputs['webcamsBest'] : '';
$webcamsVersus 			= isset($modifiedInputs['webcamsVersus']) ? $modifiedInputs['webcamsVersus'] : '';
$mapsRandom 			= isset($modifiedInputs['mapsRandom']) ? $modifiedInputs['mapsRandom'] : '';
$privacy 				= isset($modifiedInputs['privacy']) ? $modifiedInputs['privacy'] : '';
$terms 				    = isset($modifiedInputs['terms']) ? $modifiedInputs['terms'] : '';
$statement 				= isset($modifiedInputs['statement']) ? $modifiedInputs['statement'] : '';
$webcamsProfile 		= isset($modifiedInputs['webcamsProfile']) ? $modifiedInputs['webcamsProfile'] : '';
$webcamsStatsMonth      = isset($modifiedInputs['webcamsStatsMonth']) ? $modifiedInputs['webcamsStatsMonth'] : '';
$webcamsArchive         = isset($modifiedInputs['webcamsArchive']) ? $modifiedInputs['webcamsArchive'] : '';
$videosIndex     		= isset($modifiedInputs['videosIndex']) ? $modifiedInputs['videosIndex'] : '';
// ... other variables ... if you add more fields in your config.ini [urls]

	



/////////////////////////////////////////////
        //
        // webcams category tag here is the actualy categories -- (set as tag )
        //

        if ($type == 'webcams' && strpos($path, ':category') && strpos($path, ':tag')) {
            foreach ($cats as $name => $c) {
                foreach ($tags as $tname => $t) {
                    if (count($author) > 0) {
                        $meta[] = [ 
                            'name' => $name, 
                            'type' => 'webcams', 
                            'path' => str_replace(':tag', $tname, str_replace(':category', $name, $path)),
                            'title' => \Avos\Scaffold\author('category:title', [ 'category' => [$name, $tname] ]),
                            'description' => \Avos\Scaffold\author('category:description', [ 'category' => [$name, $tname] ]),
                            'keywords' => \Avos\Scaffold\author('category:keywords', [ 'category' => [$name, $tname] ], $numKeywords)
                        ];
                    }
                    else {
                        $meta[] = [
                            'name' => $name, 
                            'type' => 'webcams', 
                            'path' => str_replace(':tag', $tname, str_replace(':category', $name, $path)),
                            'title' => $c['fullname'],
                            'description' => \Avos\Scaffold\author('description'), 
                            'keywords' => \Avos\Scaffold\author('keywords', [ 'category' => $name ], $numKeywords)
                        ];
                    }
                }
            }
        }
/////////////////////////////////////////////
        //
        // webcams category - main categories 
        //

        elseif ($type == 'webcams' && strpos($path, ':category')) {
            foreach ($cats as $name => $c) {
                if (count($author) > 0) {
                    $meta[] = [ 
                        'name' => $name, 
                        'type' => 'webcams', 
                        'path' => str_replace(':category', $name, $path),
                        'title' => \Avos\Scaffold\author('category:title', [ 'category' => $name ]),
                        'description' => \Avos\Scaffold\author('category:description', [ 'category' => $name ]),
                        'keywords' => \Avos\Scaffold\author('category:keywords', [ 'category' => $name ], $numKeywords)
                    ];
                }
                else {
                    $meta[] = [
                        'name' => $name, 
                        'type' => 'webcams', 
                        'path' => str_replace(':category', $name, $path),
                        'title' => $c['fullname'],
                        'description' => \Avos\Scaffold\author('category:description'), 
                        'keywords' => \Avos\Scaffold\author('category:keywords', [ 'category' => $name ], $numKeywords)
                    ];
                }
            }
        }
/////////////////////////////////////////////
        //
        // webcams tag tags like tags/anal/* add %category% in the authorMain.csv
        //

        elseif ($type == 'webcams' && strpos($path, ':tag')) {
            foreach ($tags as $name => $t) {
                if (count($author) > 0) {

                    $meta[] = [ 
                        'name' => $name, 
                        'type' => 'webcams', 
                        'path' => str_replace(':tag', $name, $path),
                        'title' => \Avos\Scaffold\author('tag:title', [ 'category' => $name ]),
                        'description' => \Avos\Scaffold\author('tag:description', [ 'category' => $name ]),
                        'keywords' => \Avos\Scaffold\author('tag:keywords', [ 'category' => $name ], $numKeywords)
                    ];
                }
                else {
                    $meta[] = [
                        'name' => $name, 
                        'type' => 'webcams', 
                        'path' => str_replace(':tag', $name, $path),
						'title' => \Avos\Scaffold\author('tag:title', [ 'category' => $name ]),
                        'description' => \Avos\Scaffold\author('tag:description', [ 'category' => $name ]),
                        'keywords' => \Avos\Scaffold\author('tag:keywords', [ 'category' => $name ], $numKeywords)
                    ];
                }
            }
        }
/////////////////////////////////////////////
        //
        // webcams site let code site to 
        //

    

        elseif ($type == 'webcams' && strpos($path, ':site')) {
            $sites = getSites();
            foreach ($sites as $name => $t) {
                if (count($author) > 0) {

                    $meta[] = [ 
                        'name' => $t['fullname'], 
                        'type' => 'webcams', 
                        'path' => str_replace(':site', strtolower($t['fullname']), $path),
                        'title' => \Avos\Scaffold\author('category:title', [ 'category' => strtolower($t['fullname']) ]),
                        'description' => \Avos\Scaffold\author('category:description', [ 'category' => $t['fullname'] ]),
                        'keywords' => \Avos\Scaffold\author('category:keywords', [ 'category' => strtolower($t['fullname']) ], $numKeywords)
                    ];
                }
                else {
                    $meta[] = [
                        'name' => $t['fullname'], 
                        'type' => 'webcams', 
                        'path' => str_replace(':tag', strtolower($t['fullname']), $path),
                        'title' => strtolower($t['fullname']),
                        'description' => \Avos\Scaffold\author('description'), 
                        'keywords' => \Avos\Scaffold\author('keywords', [ 'category' => strtolower($t['fullname']) ], $numKeywords)
                    ];
                }
            }
        }


/////////////////////////////////////////////
//
// webcams webcamsProfile
//

elseif ($type == 'webcam' && $path === $webcamsProfile) {
    // Debugging output with hex representation

	$sites = getSites();
	foreach ($sites as $name => $t) {

		if (count($author) > 0) {

			$meta[] = [ 
				'name' =>  'Model profile',  
				'type' => $type,
				'path' => str_replace(':site', strtolower($t['fullname']), $path),
				'title' => \Avos\Scaffold\author('profile:title'),
				'description' => \Avos\Scaffold\author('profile:description'),
				'keywords' => \Avos\Scaffold\author('profile:keywords', [], $numKeywords)
			];
		}
		
	}

}

/////////////////////////////////////////////
//
// webcams stats
//


elseif ($type == 'webcam' && $path === $webcamsStatsMonth) {
    
// print_r ($webcamsStatsMonth); exit;
	
	$sites = getSites();
	foreach ($sites as $name => $t) {
	
		if (count($author) > 0) {

			$meta[] = [ 
				'name' =>  'Model stats 2',  
				'type' => $type,
				'path' => str_replace(':site', strtolower($t['fullname']), $path) .'/*',
				'title' => \Avos\Scaffold\author('statistics:title'),
				'description' => \Avos\Scaffold\author('statistics:description'),
				'keywords' => \Avos\Scaffold\author('statistics:keywords', [], $numKeywords)
			];
		}
		else {
			$meta[] = [
				'name' => $t['fullname'], 
				'type' => $type, 
				'path' => str_replace(':site', strtolower($t['fullname']), $path) .'/*',
				'title' => \Avos\Scaffold\author('statistics:title'),
				'description' => \Avos\Scaffold\author('statistics:description'),
				'keywords' => \Avos\Scaffold\author('statistics:keywords', [], $numKeywords)
			];
		}
	}

}


/////////////////////////////////////////////

// versus page 
//$webcamsVersus
elseif ($type == 'webcams' && strpos($path , $webcamsVersus) !== false)  {
 

	$sites = getSites();
	foreach ($sites as $name => $t) {
	
		if (count($author) > 0) { 
			$meta[] = [ 
				'name' => $webcamsVersus, 
				'type' => 'webcams',  
				'path' =>  $webcamsVersus,
				'title' => \Avos\Scaffold\author('vs:title'),
				'description' => \Avos\Scaffold\author('vs:description'),
				'keywords' => \Avos\Scaffold\author('vs:keywords', [], $numKeywords)
			];
		} 
		else {
			$meta[] = [
				'name' => $webcamsVersus, 
				'type' => 'webcams',  
				'path' => str_replace(':site', strtolower($t['fullname']), $path),
				'title' => \Avos\Scaffold\author('title'),
				'description' => \Avos\Scaffold\author('description'), 
				'keywords' => \Avos\Scaffold\author('vs:keywords', [], $numKeywords)
			];
		}
	}
}



//$webcamsVersus
elseif ($type == 'webcams' && strpos($path , $webcamsVersusMat) !== false)  {
	

	$sites = getSites();
	foreach ($sites as $name => $t) {
	
		if (count($author) > 0) { 
			$meta[] = [ 
				'name' =>  $webcamsVersusMat, 
				'type' => 'webcams',  
				'path' =>  $path,
				'title' => \Avos\Scaffold\author('vs:title'),
				'description' => \Avos\Scaffold\author('vs:description'),
				'keywords' => \Avos\Scaffold\author('vs:keywords', [], $numKeywords)
			];
		} 
		else {
			$meta[] = [
				'name' => $webcamsVersusMat, 
				'type' => 'webcams',  
				'path' => str_replace(':site', strtolower($t['fullname']), $path),
				'title' => \Avos\Scaffold\author('vs:title'),
				'description' => \Avos\Scaffold\author('vs:description'), 
				'keywords' => \Avos\Scaffold\author('vs:keywords', [], $numKeywords)
			];
		}
	}
}


//difrent page as discover
//$webcamsDiscover
if ($type == 'none' && strpos($path, $webcamsDiscover) !== false )    {

	$sites = getSites();
	foreach ($sites as $name => $t) {
		if (count($author) > 0) {

			$meta[] = [
				'name' => $webcamsDiscover, 
				'type' => 'none',
				'path' => $path,
				'title' => \Avos\Scaffold\author('discover:title', [ 'mysite' => $mysite ]),
				'description' => \Avos\Scaffold\author('discover:description'),
				'keywords' => \Avos\Scaffold\author('discover:keywords', [], $numKeywords) 
			];
		}  
		else {
			$meta[] = [	//META FOR HOME PAGE IS STE HERE 		
				'name' => '', 
				'type' => 'none',
				'path' => $path,
				'title' => \Avos\Scaffold\author('discover:title'),
				'description' => \Avos\Scaffold\author('discover:description'),
				'keywords' => \Avos\Scaffold\author('discover:keywords', [], $numKeywords) 
			];
		}
	}
}



// custom page 

if ($type == 'webcams' && strpos($path, $webcamsCustom) !== false )    {

	$sites = getSites();
	foreach ($sites as $name => $t) {
		if (count($author) > 0) {

			$meta[] = [
				'name' => $webcamsCustom, 
				'type' => 'webcams', 
				'path' => $webcamsCustom,
				'title' => \Avos\Scaffold\author('custom:title', [ 'mysite' => $mysite ]),
				'description' => \Avos\Scaffold\author('custom:description'),
				'keywords' => \Avos\Scaffold\author('custom:keywords', [], $numKeywords) 
			];
		}  
		else {
			$meta[] = [	//META FOR HOME PAGE IS STE HERE 		
				'name' => $webcamsCustom, 
				'type' => 'none',
				'path' => $webcamsCustom,
				'title' => \Avos\Scaffold\author('custom:title'),
				'description' => \Avos\Scaffold\author('custom:description'),
				'keywords' => \Avos\Scaffold\author('custom:keywords', [], $numKeywords) 
			];
		}
	}
}
//end of custom page 
// multi page 

if ($type == 'webcams' && strpos($path, $webcamsMulti) !== false )    {
	

	$sites = getSites();
	foreach ($sites as $name => $t) {
		if (count($author) > 0) {

			$meta[] = [
				'name' => $webcamsMulti, 
				'type' => 'webcams', 
				'path' => $path,
				'title' => \Avos\Scaffold\author('multi:title', [ 'mysite' => $mysite ]),
				'description' => \Avos\Scaffold\author('multi:description'),
				'keywords' => \Avos\Scaffold\author('multi:keywords', [], $numKeywords) 
			];
		}  

		else {
			$meta[] = [	//META FOR HOME PAGE IS STE HERE 		
				'name' => $webcamsMulti, 
				'type' => 'webcams',
				'path' => $webcamsMulti,
				'title' => \Avos\Scaffold\author('multi:title'),
				'description' => \Avos\Scaffold\author('multi:description'),
				'keywords' => \Avos\Scaffold\author(':keywords', [], $numKeywords) 
			];
		}
	}
}


/////////////////////////////////////////////

// versus page 
//$webcamsVersus
elseif ($type == 'webcams' && strpos($path , $webcamsLiveTv) !== false)  {
 

	$sites = getSites();
	foreach ($sites as $name => $t) {
	
		if (count($author) > 0) { 
			$meta[] = [ 
				'name' =>'Live Tv - Chaturbate vs StripChat', 
				'type' => 'webcams',  
				'path' =>  $webcamsLiveTv,
				'title' => \Avos\Scaffold\author('tv:title'),
				'description' => \Avos\Scaffold\author('tv:description'),
				'keywords' => \Avos\Scaffold\author('tv:keywords', [], $numKeywords)
			];
		} 
	
	}
}










// offline pages  

if ($type == 'webcams' && strpos($path, $webcamsArchive) !== false )    {

	$sites = getSites();
	foreach ($sites as $name => $t) { 
		if (count($author) > 0) {

			$meta[] = [
				'name' => $webcamsArchive, 
				'type' => 'webcams', 
				'path' => $webcamsArchive,
				'title' => \Avos\Scaffold\author('archive:title', [ 'mysite' => $mysite ]),
				'description' => \Avos\Scaffold\author('archive:description'),
				'keywords' => \Avos\Scaffold\author('archive:keywords', [], $numKeywords) 
			];
		}  
		else {
			$meta[] = [	//META FOR HOME PAGE IS STE HERE 		
				'name' => $webcamsArchive, 
				'type' => 'none',
				'path' => $webcamsArchive,
				'title' => \Avos\Scaffold\author('archive:title'),
				'description' => \Avos\Scaffold\author('archive:description'),
				'keywords' => \Avos\Scaffold\author('archive:keywords', [], $numKeywords) 
			];
		}
	}
}


//

if ($type == 'none' && strpos($path, $webcamsTagspage) !== false )    {

	$sites = getSites();
	foreach ($sites as $name => $t) {
		if (count($author) > 0) {

			$meta[] = [
				'name' => $webcamsTagspage, 
				'type' => 'none tags', 
				'path' => $path,
				'title' => \Avos\Scaffold\author('tags:title', [ 'mysite' => $mysite ]),
				'description' => \Avos\Scaffold\author('tags:description'),
				'keywords' => \Avos\Scaffold\author('tags:keywords', [], $numKeywords) 
			];
		}  

		else {
			$meta[] = [	//META FOR HOME PAGE IS STE HERE 		
				'name' => $webcamsTagspage,  
				'type' => 'none',
				'path' => $path,
				'title' => \Avos\Scaffold\author(':title'),
				'description' => \Avos\Scaffold\author(':description'),
				'keywords' => \Avos\Scaffold\author(':keywords', [], $numKeywords) 
			];
		}
	}
}





//end of multi page 

// home page
elseif ($type == 'none' && $path === '/' )    {

//	print_r ($path); exit; 

	$sites = getSites();
	foreach ($sites as $name => $t) {
		if (count($author) > 0) {

			$meta[] = [
				'name' => '', 
				'type' => 'none',
				'path' => $path,
				'title' => \Avos\Scaffold\author('index:title', [ 'mysite' => $mysite ]),
				'description' => \Avos\Scaffold\author('index:description'),
				'keywords' => \Avos\Scaffold\author('index:keywords', [], $numKeywords) 
			];
		}  
		else {
			$meta[] = [	//META FOR HOME PAGE IS STE HERE 		
				'name' => '', 
				'type' => 'none', 
				'path' => $path,
				'title' => \Avos\Scaffold\author('index:title'),
				'description' => \Avos\Scaffold\author('index:description'),
				'keywords' => \Avos\Scaffold\author('index:keywords', [], $numKeywords) 
			];
		}
	}
}


 //
        // videos
        //

        elseif ($type == 'videos' && strpos($path, ':sort')) {
            $meta[] = ['name' => 'latest', 'title' => 'Latest Videos', 'type' => 'videos', 'path' => str_replace(':sort', 'latest', $path)];
            $meta[] = ['name' => 'popular', 'title' => 'Most Popular Videos', 'type' => 'videos', 'path' => str_replace(':sort', 'popular', $path)];
            $meta[] = ['name' => 'longest', 'title' => 'Longest Videos', 'type' => 'videos', 'path' => str_replace(':sort', 'longest', $path)];
            $meta[] = ['name' => 'last viewed', 'title' => 'Last Viewed Videos', 'type' => 'videos', 'path' => str_replace(':sort', 'viewed', $path)];
        }

        //
        // video
        //
		elseif ($type == 'videos') {
            $meta[] = [
                'name' => 'videos', 
                'type' => $type, 
                'path' => $path,
                'title' => $metaVideos[0]['meta_title'], 
                'description' =>$metaVideos[0]['meta_description'], 
                'keywords' => $metaVideos[0]['meta_keywords']
            ];
        }

        elseif ($type == 'video') {
            $meta[] = [
                'name' => 'video', 
                'type' => $type, 
                'path' => $path,
                'title' => ':title', 
                'description' => ':short_description', 
                'keywords' => ':videokeywords'
            ];
        }

        //
        // galleries
        //

        elseif ($type == 'photos' && strpos($path, ':sort')) {
            $meta[] = ['name' => 'latest', 'title' => 'Latest Galleries', 'type' => 'photos', 'path' => str_replace(':sort', 'latest', $path)];
            $meta[] = ['name' => 'popular', 'title' => 'Most Popular Galleries', 'type' => 'photos', 'path' => str_replace(':sort', 'popular', $path)];
            $meta[] = ['name' => 'longest', 'title' => 'Biggest Galleries', 'type' => 'photos', 'path' => str_replace(':sort', 'total', $path)];
            $meta[] = ['name' => 'last viewed', 'title' => 'Last Viewed Galleries', 'type' => 'photos', 'path' => str_replace(':sort', 'viewed', $path)];
        }

        //
        // gallery
        //
		elseif ($type == 'photos') {
            $meta[] = [
                'name' => 'photos', 
                'type' => $type, 
                'path' => $path,
                'title' => $metaPhotos[0]['meta_title'], 
                'description' =>$metaPhotos[0]['meta_description'], 
                'keywords' => $metaPhotos[0]['meta_keywords']
            ];
        }

        elseif ($type == 'photo') {
            $meta[] = [
                'name' => 'photo', 
                'type' => $type, 
                'path' => $path,
                'title' => ':title', 
                'description' => ':short_description', 
                'keywords' => ':photokeywords'
            ];
        }

//
//promote meta
//

elseif ($type == 'promote' )    {

	
	

			$meta[] = [
				'name' => 'promote websites', 
				'type' => $type, 
                'path' => $path,
                'title' => $promote[0]['title'], 
                'description' => $promote[0]['description'], 
                'keywords' =>$promote[0]['keywords']
			];
	
	
}

elseif ($type == 'promot' )    {

	$sites = getSites();
	foreach ($sites as $name => $t) {
		if (count($author) > 0) {

			$meta[] = [
				'name' => '', 
				'type' => $type, 
                'path' => $path,
                'title' => ':title', 
                'description' => ':description', 
                'keywords' =>':keywords'
			];
		}  
		
	}
}
//
//promote meta
//


//
//casino 
//
elseif ($type == 'casino' ){

	$meta[] = [
		'name' => 'Casino', 
		'type' => $type, 
		'path' => $path,
		'title' =>  \Avos\Scaffold\author('casino:title'), 
        'description' => \Avos\Scaffold\author('casino:description'), 
        'keywords' => \Avos\Scaffold\author('casino:keywords', [], $numKeywords)
	];


}
 

   		//
        // blogs meta
        //


		elseif ($type == 'blogs') {
            $meta[] = [
                'name' => 'blogs', 
                'type' => $type, 
                'path' => $path,
				'title' =>  \Avos\Scaffold\author('blogs:title'), 
                'description' => \Avos\Scaffold\author('blogs:description'), 
                'keywords' => \Avos\Scaffold\author('blogs:keywords', [], $numKeywords)



				//print_r($path);exit;
            ];
        }
		$metaBlogs = \Avos\Database\queryAssoc("SELECT * FROM ArticleBlogPosts");


		if ($type == 'blog' && !empty($metaBlogs)) {
			foreach ($metaBlogs as $blog) {
				$meta[] = [
					'name' => 'blog post',
					'type' => $type,
					'path' => $path,
					'id' => $blog['id'], // Add this line to include the 'id' field
					'title' => ':Title',
					'description' => ':Description',
					'keywords' => ':blogkeywords',
					// Add other fields as needed
				];
			}
		}
		

		
        //
        // default
        //

        else {
            if (!empty($category) && $u[2] != '/') {
                $meta[] = [ 
                    'name' => '', 
                    'type' => $type,
                    'path' => $path,
                    'title' => \Avos\Scaffold\author('category:title', [ 'category' => $category ]),
                    'description' => \Avos\Scaffold\author('category:description', [ 'category' => $category ]),
                    'keywords' => \Avos\Scaffold\author('category:keywords', [ 'category' => $category ], $numKeywords)
                ];
            }
            else {
                $meta[] = [

					'name' => 'fuck this is none on categories default - admin', 
					'type' => 'none',
					'path' => $path,
					'title' => \Avos\Scaffold\author('title'),
					'description' => \Avos\Scaffold\author('description'),
					'keywords' => \Avos\Scaffold\author('keywords', [], $numKeywords) 



                ];
            }
        }
    }

    //
    // we need keywords to be a csv
    //

    foreach ($meta as $i => $m) {
        if (isset($m['keywords']) && is_array($m['keywords'])) {
            $meta[$i]['keywords'] = implode(',', $m['keywords']);
			
        }
    }

    //
    // output
    //

    if ($_POST['download']) {
        \header('Content-Description: File Transfer');
        \header('Content-Type: application/octet-stream');
        \header("Content-Type: application/force-download");
        \header("Content-Type: application/download");
        \header('Content-Disposition: attachment; filename="meta.' . $_POST['format'] . '"');
        \header('Expires: 0');
        \header('Cache-Control: must-revalidate');
        \header('Pragma: public');
    }
    else {
        \header("Content-type: text/plain"); 
    }

    $template = 'metaGenerator' . ucfirst($_POST['format']) . '.php';
    echo parsePhpTemplate($template, array('meta' => $meta, 'fields' => explode(',', $_POST['fields'])));
    exit; 
}

////////////////////////////////////////////////////////////////////////////////////////////

function tags()
{
	if (!isset($_SESSION['loggedin'])) {
		return array('redirect' => '?page=login');
	}
    global $_AVOS;

    if (!isset($_SESSION['loggedin'])) {
        return array('redirect' => '?page=login');
    }

    $tags = $_AVOS['redis']->get('siteTags');

    if (isset($_GET['format'])) {
        return array(
            'args' => array(
            'tags' => $tags
            ),
            'ftemplate' => 'webcamsTagsCSV.php',
            'type' => 'csv'
        );
    }
    #echo "<pre>"; print_r($tags);exit;

    if (!empty($_GET['kw']) && preg_match('!^[\-\s\w]+$!', $_GET['kw'])) {
        $ntags = array();
        foreach ($tags as $n => $t) {
            if (strpos($n, $_GET['kw']) !== false) {
                $ntags[$n] = $t;
            }
        }
        $tags = $ntags;
    }

    return array(
        'args' => array(
            'tags' => $tags
        ),
        'template' => 'webcamsTags.php'
    );
}

////////////////////////////////////////////////////////////////////////////////////////////

function videos()
{
    if (!isset($_SESSION['loggedin'])) {
        return array('redirect' => '?page=login');
    }

    if (isset($_GET['unpublish'])) {
        $id = (int)$_GET['unpublish'];
        \Avos\Database\query("update videos set publishedon=0 where id=$id");
        \redirect('/admin/' . urldecode($_GET['from']));
    }

    else if (isset($_GET['publish'])) {
        $id = (int)$_GET['publish'];
        \Avos\Database\query("update videos set publishedon=unix_timestamp() where id=$id");
        \redirect('/admin/' . urldecode($_GET['from']));
    }

    else if (isset($_GET['delete'])) {
        $args = array('id' => (int)$_GET['delete']);
        list($args['info']) = \Avos\Database\queryList("select filename from videos where id=:id", $args);
        \Avos\Database\query("delete from videos where id=:id", $args);
        \Avos\Database\query("insert into videosActions (videosId, action, info) values (:id, 'delete', :info)", $args);
        \redirect('/admin/' . urldecode($_GET['from']));
    }

    $where = '';
    if (!empty($_GET['kw'])) {
        $kw = mysqli_real_escape_string(\Avos\Database\dbh(), $_GET['kw']);
        $where = "WHERE (title LIKE '%$kw%' OR description LIKE '%$kw%' OR tags LIKE '%$kw%')";
    }

    $status = isset($_GET['status']) ? $_GET['status'] : 'unpubincomp';

    if ($status != 'all') {
        if (empty($where)) {
            $where = "WHERE ";
        }
        else {
            $where .= " AND ";
        }

        switch ($status) {
            case 'unpubcomp':
                $where .= "publishedon=0 AND processed=1 AND tags != '' AND description != ''";
                break;
            case 'unpubincomp':
                $where .= "publishedon=0 AND processed=1 AND (tags = '' OR description = '')";
                break;
			case 'complete':
                $where .= "processed=1 AND tags != '' AND description != ''";
				break;
            case 'procunpub':
                $where .= "publishedon=0 AND processed=1";
                break;
            case 'published':
                $where .= "publishedon>0";
                break;
			case 'unpublished':
				$where .= "publishedon=0";
				break;
			case 'processed':
				$where .= "processed=1";
				break;
			case 'unprocessed':
				$where .= "processed=0";
				break;
		}
	}

	// so we can get back here after editing
	$from = "?page=videos&status=$status";
	if (!empty($_GET['kw'])) $from .= "&kw=" . $_GET['kw'];
	$from = urlencode($from);

	$videos = \Avos\Database\queryAssoc("select v.id, videosId as pendingAction, mainThumb, duration, title, views, filename, processed, publishedon, description from videos v left join videosActions va on v.id=va.videosId $where order by publishedon desc, id desc");

	foreach ($videos as $i => $v) {
		$videos[$i]['processed'] = $v['processed'] == 1 ? 'Yes' : 'No';

		if ($v['publishedon'] > 0) {
			$videos[$i]['publishedonstr'] = date('d M Y H:i:s', $v['publishedon']);
		}
		else {
			$videos[$i]['publishedonstr'] = 'No';
		}

		$videos[$i]['imagePath'] = \Avos\Videos\videoPath($v['filename'], true);
		$videos[$i]['duration'] = \Avos\Utils\seconds2string($v['duration']);

		//description
	}

	return array(
		'args' => array(
			'videos' => $videos,
			'status' => $status,
			'from' => $from
		),
		'template' => 'videos.php'
	);
}

////////////////////////////////////////////////////////////////////////////////////////////




function videosEdit()
{
   
    // Check if form data is submitted
    if (count($_POST) > 0) {
        // Sanitize and validate input data
		
        $queryParams = array(
            'id' => $_POST['id'],
            'title' => filter_var($_POST['title'], FILTER_SANITIZE_STRING),
			'categories' => filter_var($_POST['categories'], FILTER_SANITIZE_STRING),
			'website_model' => filter_var($_POST['website_model'], FILTER_SANITIZE_STRING),
            'tags' => filter_var($_POST['tags'], FILTER_SANITIZE_STRING),
            'description' => filter_var($_POST['description'], FILTER_SANITIZE_STRING),
			'short_description' => filter_var($_POST['short_description'], FILTER_SANITIZE_STRING),
            'mainThumb' => filter_var($_POST['mainThumb'], FILTER_SANITIZE_STRING),
            'videokeywords' => filter_var($_POST['videokeywords'], FILTER_SANITIZE_STRING),
			'post_date' => filter_var($_POST['post_date'], FILTER_SANITIZE_STRING),
			'post_by' => filter_var($_POST['post_by'], FILTER_SANITIZE_STRING),
			
        );
	
        // Use prepared statements or parameterized queries to prevent SQL injection
        \Avos\Database\query("
            UPDATE videos
            SET title=:title, tags=:tags, description=:description, post_date=:post_date, post_by=:post_by, mainThumb=:mainThumb, short_description=:short_description, categories=:categories, website_model=:website_model, videokeywords=:videokeywords
            WHERE id=:id
        ", $queryParams);

		
        // Insert into videosActions table
        \Avos\Database\query("
            INSERT INTO videosActions (videosId, action, info)
            VALUES (:id, 'rename', :title)
        ", $queryParams);

        // Refresh video tags
        \Avos\Cron\refreshVideosTags();

        // Redirect to the appropriate page
        \redirect('/admin/' . urldecode($_POST['from']));
    }

    // Display the video editor page
    list($video) = \Avos\Database\queryAssoc("SELECT * FROM videos WHERE id=:id", array('id' => $_GET['id']));
    $video['imagePath'] = \Avos\Videos\videoPath($video['filename'], true);

    return array(
        'args' => array(
            'video' => $video,
            'tags' => \Avos\Database\query("SELECT name, COUNT(*) AS num FROM videosTags GROUP BY name"),
            'from' => $_GET['from']
        ),
        'template' => 'videosEdit.php'
    );
}



////////////////////////////////////////////////////////////////////////////////////////////
 
function photos()
{
	if (!isset($_SESSION['loggedin'])) {
		return array('redirect' => '?page=login');
	}

	if (isset($_GET['unpublish'])) {
		$id = (int)$_GET['unpublish'];
		\Avos\Database\query("update photos set publishedon=0 where id=$id");
	}

	else if (isset($_GET['publish'])) {
		$id = (int)$_GET['publish'];
		\Avos\Database\query("update photos set publishedon=unix_timestamp() where id=$id");
	}

	else if (isset($_GET['delete'])) {
		$args = array('id' => (int)$_GET['delete']);
		list($args['info']) = \Avos\Database\queryList("select folder from photos where id=:id", $args);
		\Avos\Database\query("delete from photos where id=:id", $args);
		\Avos\Database\query("insert into photosActions (photosId, action, info) values (:id, 'delete', :info)", $args);
		#\redirect(urldecode($_GET['from']));
	}

	$where = '';
	if (!empty($_GET['kw'])) {
		$kw = mysqli_real_escape_string(\Avos\Database\dbh(), $_GET['kw']);
		$where = "WHERE title LIKE '%$kw%' OR description LIKE '%$kw%' OR tags LIKE '%$kw%'";
	}

	$photos = \Avos\Database\queryAssoc("select id, title, views, folder, publishedon, mainPhoto, numPhotos from photos $where order by publishedon desc, id desc");

	foreach ($photos as $i => $v) {
		if ($v['publishedon'] > 0) {
			$photos[$i]['publishedonstr'] = date('d M Y H:i:s', $v['publishedon']);
		}
		else {
			$photos[$i]['publishedonstr'] = 'No';
		}

		//print_r($v['folder']); 

		//$photos[$i]['photosPath'] = \Avos\Photos\photoPath($v['folder'], true);
		$photos[$i]['photosPath'] = preg_replace('/-1/', '', \Avos\Photos\photoPath($v['folder'], true));
		
	}

	return array(
		'args' => array(
			'photos' => $photos
		),
		'template' => 'photos.php'
	);
}

////////////////////////////////////////////////////////////////////////////////////////////

function photosEdit()
{
    // Check if form data is submitted
    if (count($_POST) > 0) {
		echo "Form submitted!";
        // Sanitize and validate input data
        $queryParamsPhotos = array(
            'id' => $_POST['id'],
            'title' => filter_var($_POST['title'], FILTER_SANITIZE_STRING),
            'categories' => filter_var($_POST['categories'], FILTER_SANITIZE_STRING),
            'website_model' => filter_var($_POST['website_model'], FILTER_SANITIZE_STRING),
            'tags' => filter_var($_POST['tags'], FILTER_SANITIZE_STRING),
            'description' => filter_var($_POST['description'], FILTER_SANITIZE_STRING),
            'short_description' => filter_var($_POST['short_description'], FILTER_SANITIZE_STRING),
            'mainPhoto' => filter_var($_POST['mainPhoto'], FILTER_SANITIZE_STRING),
            'photokeywords' => filter_var($_POST['photokeywords'], FILTER_SANITIZE_STRING),
            'post_by' => filter_var($_POST['post_by'], FILTER_SANITIZE_STRING),
        );
// Before executing the UPDATE query
// After executing the UPDATE query
\Avos\Database\query("
    UPDATE photos
    SET title=:title, tags=:tags, description=:description, post_by=:post_by, mainPhoto=:mainPhoto, short_description=:short_description, categories=:categories, website_model=:website_model, photokeywords=:photokeywords
    WHERE id=:id
", $queryParamsPhotos);

//echo "Update query executed successfully!";



        \Avos\Database\query("
            INSERT INTO photosActions (photosId, action, info)
            VALUES (:id, 'rename', :title)
        ", $queryParamsPhotos);

        \redirect('/admin/?page=photos');
    }

    // Display the photo editor page
    if (isset($_GET['id'])) {
        list($photos) = \Avos\Database\queryAssoc("SELECT * FROM photos WHERE id=:id", array('id' => $_GET['id']));
        $photos['photosPath'] = \Avos\Photos\photoPath($photos['folder'], true);

        return array(
            'args' => array(
                'photos' => $photos,
                'tags' => \Avos\Database\query("SELECT name, COUNT(*) AS num FROM photosTags GROUP BY name")
            ),
            'template' => 'photosEdit.php'
        );
    } else {
        // Handle the error or redirect as needed
        return array('error' => 'Invalid request');
    }


	
}



////////////////////////////////////////////////////////////////////////////////////////////



///////////////////////////////////////////blog-list/////////////////////////////////////////////////

function blogList()
{
	global $_AVOS;
	
    if (!isset($_SESSION['loggedin'])) {
        return array('redirect' => '?page=login');
    }

    if (isset($_GET['unpublish'])) 
	{
        $id = (int)$_GET['unpublish'];
        \Avos\Database\query("UPDATE ArticleBlogPosts SET publishedOn=0 WHERE id=$id");
		
    } 
	
	else if (isset($_GET['publish']))
	 {
        $id = (int)$_GET['publish'];
		\Avos\Database\query("UPDATE ArticleBlogPosts SET publishedOn = FROM_UNIXTIME(1691940132) WHERE id=$id");

		//print_r($id);
		
     
	
} else if (isset($_GET['delete'])) {
    $idToDelete = (int)$_GET['delete'];
    
    //$imageDir = $_AVOS['config']['blog']['blogPhotosUrl'] . $idToDelete; // Fetch the directory path using a query
    
	$imageDir = $_AVOS['config']['blog']['blogPhotosUrl'] . $idToDelete; // Fetch the directory path using a query
    
	//sftp://ns514412.ip-198-27-68.net/var/www/html/avos.wetpussygirls.com/web/photosBlog/170
    // Get the last part of the directory path (like "172")
    $dirNameToDelete = basename($imageDir);

    // Delete the directory along with its contents
    if (is_dir($imageDir)) {
        // Recursively remove the directory and its contents
        \Avos\Filesystem\removeDirectory($imageDir);

	
    }
    
    // Perform deletion from MySQL
    \Avos\Database\query("DELETE FROM ArticleBlogPosts WHERE id=$idToDelete");
    
    // Redirect to the blog list page after deletion
    header("Location: ?page=blog-list"); 
    exit();
}




$where = '';
	if (!empty($_GET['kw'])) {
		$kw = mysqli_real_escape_string(\Avos\Database\dbh(), $_GET['kw']);
		$where = "WHERE Title LIKE '%$kw%' OR Description LIKE '%$kw%' OR Tags LIKE '%$kw%'";
	}

	//$blogs = \Avos\Database\queryAssoc("select * from ArticleBlogPosts $where order by publishedOn desc, id desc");



//print_r($blogs);exit;


	

	
    // Rest of your code...
	//echo "Function Executed1";

    return array(
        'args' => array(
            'blogs' => $blogs
        ),
        'template' => 'blogList.php',
		
    );
}

///////////////////////////////////////////blog-list/////////////////////////////////////////////////

/////////////////create blog/////////////


function blogCreate()
{
	

	if (!isset($_SESSION['loggedin'])) {
		return array('redirect' => '?page=login');
	}


	return array(
		'args' => array(
			'blog' => $blog
		),
		'template' => 'blogCreate.php'
	);
	
}
/////////////////create blog/////////////


/////////////////edit blog/////////////



function blogEdit()
{
	if (!isset($_SESSION['loggedin'])) {
		return array('redirect' => '?page=login');
	}
	
	return array(
		'args' => array(
			'blog' => $blog,
			//'tags' => \Avos\Database\query("SELECT name, COUNT(*) AS num FROM photosTags GROUP BY name")
		),
		'template' => 'blogEdit.php'
	);
}



/////////////////edit blog/////////////



/////////////////create blog/////////////


function sitesCreate()
{
	

	if (!isset($_SESSION['loggedin'])) {
		return array('redirect' => '?page=login');
	}


	return array(
		'args' => array(
			'promot' => $promot
		),
		'template' => 'sitesCreate.php'
	);
	
}
/////////////////create blog/////////////






/////////////////edit promote sites list/////////////





function sitesEdit()
{
    global $_AVOS;

    if (!isset($_SESSION['loggedin'])) {
        return array('redirect' => '?page=login');
    }

    // Check if the site ID is provided in the URL
    if (isset($_GET['id'])) {
        $siteId = (int)$_GET['id'];

        // Retrieve site details based on the site ID
        $result = \Avos\Database\query("SELECT * FROM promote WHERE siteId = $siteId");

        if ($result->num_rows > 0) {
            $promote = $result->fetch_assoc();
        } else {
            echo "Site not found";
            exit();
        }
    } else {
        echo "Site ID not provided";
        exit();
    }

    return array(
        'args' => array(
            'promot' => $promot,
        ),
        'template' => 'sitesEdit.php',
    );
}





/////////////////edit promote sites list/////////////


function sitesList()
{
    global $_AVOS;

    if (!isset($_SESSION['loggedin'])) {
        return array('redirect' => '?page=login');
    }

    if (isset($_GET['unpublish'])) {
        $id = (int)$_GET['unpublish'];
        \Avos\Database\query("UPDATE promote SET publishedOn=NULL WHERE siteId=$id");
    } elseif (isset($_GET['publish'])) {
        $id = (int)$_GET['publish'];
        \Avos\Database\query("UPDATE promote SET publishedOn=FROM_UNIXTIME(1691940132) WHERE siteId=$id");
    } elseif (isset($_GET['edit'])) {
        $id = (int)$_GET['edit'];
        // Redirect to the edit page with the site ID as a parameter
        header("Location: ?page=sites-edit&siteId=$id");
        exit();
    }elseif (isset($_GET['delete'])) {
		$id = (int)$_GET['delete'];
		
		// Step 1: Delete dependent records in model_social_links first
		$deleteSocialLinksQuery = "DELETE FROM model_social_links WHERE model_id=$id";
		$result = \Avos\Database\query($deleteSocialLinksQuery);
	
		// Step 2: Now delete from promote table
		$deletePromoteQuery = "DELETE FROM promote WHERE siteId=$id";
		$result = \Avos\Database\query($deletePromoteQuery);
	
		// Check if the deletion was successful
		if (!$result) {
			$error = \Avos\Database::getError();
			echo "<script>alert('Query failed. Error: $error');</script>";
		} else {
			echo "<script>alert('Delete successful');</script>";
		}
	
		// Redirect to the sites list page after deletion
		header("Location: ?page=sites-list");
		exit();
	}
	

	
    // Retrieve data from the promote table
    $sql = "SELECT * FROM promote";
    $result = \Avos\Database\query($sql);

    // Fetch the data into an associative array
    $promote = $result->fetch_all(MYSQLI_ASSOC);

    return array(
        'args' => array(
            'promote' => $promote
        ),
        'template' => 'sitesList.php',
    );
}
///////////////////////////////////////////sitesList-list/////////////////////////////////////////////////






function logs()
{
	if (!isset($_SESSION['loggedin'])) {
		return array('redirect' => '?page=login');
	}
	global $_AVOS;
	$dir = $_AVOS['config']['site']['avosDir'] . 'logs/';

	if (isset($_GET['file'])) {
		// hacking sanity check
		if (preg_match('!^[\w\.]+$!', $_GET['file'])) {
			$log = file_get_contents($dir . $_GET['file']);

			// remove html comment tags
			$log = str_replace(array('<!--', '-->'), '', $log);

			return array(
				'args' => array(
					'file' => $_GET['file'],
					'log' => $log
				),
				'template' => 'log.php'
			);
		}
		else {
			return array('template' => '404.php');
		}
	}
	else {
		$tmp = \Avos\Utils\list_files($dir);
		$logs = array();

		foreach ($tmp as $l) {
			$logs[] = array(
				'file' => $l,
				'epochTime' => filemtime($dir . $l)
			);
		}

		return array(
			'args' => array(
				'logs' => $logs
			),
			'template' => 'logs.php'
		);
	}
}

////////////////////////////////////////////////////////////////////////////////////////////

function login()
{
    global $_AVOS;

	if (count($_POST) > 0) {
		if ($_POST['password'] == $_AVOS['config']['site']['adminLogon']) {
			$_SESSION['loggedin'] = 1;
			return array('redirect' => '?');
		}
	}

	return array('ftemplate' => 'login.php');
}

////////////////////////////////////////////////////////////////////////////////////////////

function logout()
{
        session_destroy();
        return array('redirect' => '?');
}





/*

function users()
{
	
	
	return array(
		'args' => array(
			'blog' => $blog,
			//'tags' => \Avos\Database\query("SELECT name, COUNT(*) AS num FROM photosTags GROUP BY name")
		),
		'template' => 'userIndex.php'
	);
}
*/











function parsePhpTemplate($template, $args=array())
{
	global $_AVOS;

    foreach ($args as $k  => $v) {
        $$k = $v;
    }

	$TOP = "";

	// make some variables more available to the templates
	if (isset($_AVOS['page']['page'])) $page = $_AVOS['page']['page'];
	if (isset($_AVOS['page']['pages'])) $pages = $_AVOS['page']['pages'];
	if (isset($_AVOS['page']['title'])) $title = $_AVOS['page']['title'];
	if (isset($_AVOS['page']['matches'])) $matches = $_AVOS['page']['matches'];

    ob_start();
    include(TEMPLATES . $template);
    $html = ob_get_contents();
    ob_end_clean();

    return $html;
}

function route($routes)
{
	//
	// see if we have a matching route
	//

	$req = (isset($_GET['page'])) ? $_GET['page'] : '';
	//$path = str_replace(URL, '', $req);
	$path = $req;
	$path = preg_replace('!(\?.*)!', '', $path);
	$path = preg_replace('!^//?!', '', $path);
	#$path = preg_replace('!^v2/!', '', $path);

	//
	// call the first matching route
	//

	$found_route = false;

	foreach ($routes as $r) {
		#echo "checking:"; print_r($r); echo "<br>";
		#$re = '!^' . preg_replace(array('!/!', '!:(\w+)!'), array('\\/', '(?P<$1>[\w\-\.]+)'), $r[0]) . '$!';
		$re = '!^' . preg_replace(array('!/!', '!:(\w+)!'), array('\\/', '(?P<$1>([^/]+)?)'), $r[0]) . '$!';
		#echo "path=$path re=$re<br>";

		if (preg_match($re, $path, $args)) {
			$found_route = true;
			#echo "calling $r[1]";exit;
			$ret = call_user_func('\\Avos\\Admin\\' . $r[1], $args);

			if (is_array($ret)) {
				if (isset($ret['args']) && is_array($ret['args'])) {
					$targs = $ret['args'];
				}
				else {
					$targs = array();
				}

				if (isset($ret['type'])) {
					if ($ret['type'] == 'csv') {
						header("Content-type: text/csv");
					}
				}

				if (isset($ret['ftemplate'])) {
					if (preg_match('!\.php$!', $ret['ftemplate'])) {
						echo \Avos\Admin\parsePhpTemplate($ret['ftemplate'], $targs);
					}
					else {
						echo \Avos\Admin\parseTemplate($ret['ftemplate'], $targs);
					}
				}

				elseif (isset($ret['template'])) {
					$targs['page_contents'] =  \Avos\Admin\parsePhpTemplate($ret['template'], $targs);
					echo \Avos\Admin\parsePhpTemplate('layout.php', $targs);
				}
				elseif (isset($ret['html'])) {
					$targs['page_contents'] =  $ret['html'];
					echo \Avos\Scaffold\parsePhpTemplate('layout.php', $targs);
				}
				elseif (isset($ret['redirect'])) {
					header("Location: $ret[redirect]", true, 302);
					exit;
				}
			}
			else {
				echo $ret;
			}

			exit;
		}
	}

	if (!$found_route) {
		echo \Avos\Admin\parsePhpTemplate('layout.php',
			array('page_contents' => \Avos\Admin\parsePhpTemplate('404.php'))
		);
		exit;
	}
}
