<?php
namespace Sites\MyFreeCams;

function get_shortname()
{
    return 'mf';
}

function online_status() {
    global $_AVOS;

   // $token = 'a3b850c0-45d9-11ef-a538-c7df73babb24';
       // Corrected token retrieval
	   $token = isset($_AVOS['config']['webcams']['MyFreeCams']['api_key']) 
	   ? $_AVOS['config']['webcams']['MyFreeCams']['api_key'] 
	   : '';

   // Validate if the token is set
   if (empty($token)) {
	   echo "API token is not set.\n";
	   return [];
   }

    $url = 'https://external-api.camshq.info/';

    $postData = json_encode([
        'query' => '
        {
            LivePerformers(
                token: "' . $token . '"
                filters: [{ key: "gender", value: "f" }]
                pager: { page: 0, size: 1000 }
            ) {
                Pager {
                    page
                    pages
                    total
                    size
                }
                Data {
                    room_url
                    system_source_name
                    score
                    name
                    age
                    ethnicity
                    bust_size
                    eye_color
                    pubic_hair
                    fetishes
                    hair_color
                    height
                    weight
                    body_type
                    sexual_preferences
                    gender
                    profile_url
                    profile_image_full_proxy_url
                    event_stream_url
                    room_subject
                    system_last_live
                }
            }
        }'
    ]);

    $options = [
        'http' => [
            'header'  => "Content-type: application/json\r\n",
            'method'  => 'POST',
            'content' => $postData,
        ],
    ];

    $context  = stream_context_create($options);
    $result = file_get_contents($url, false, $context);

    if ($result === FALSE) {
        echo "Error occurred while fetching data\n";
        return [];
    }

    $data = json_decode($result, true);
    if (!isset($data['data']['LivePerformers']['Data']) || !is_array($data['data']['LivePerformers']['Data'])) {
        echo "No valid data found\n";
        return [];
    }

    // Default tags array
    $defaultTags = [
		'Strip', 'Dance', 'Oil show', 'Toy show',
        'Strip tease', 'Naked', 'Flash', 'Special surprise',
        'Role play', 'Cosplay show','anal','boobs','cum','pussy','sex show','cams','online','freechat','sex','blowjobs','ass','toys','teen','milf','group','best','ass play','shaved','natural','alpha','amateur','anal-teens','fingering','asstomouth'
        ,'athletic','babe','licking','c2c','rubbing','free','wet','ahegao','anal-teens'
    ];

    $models = [];
    $defaultTagIndex = 0;

    foreach ($data['data']['LivePerformers']['Data'] as $m) {
        $tags = $m['fetishes'] ? implode(',', explode(',', $m['fetishes'])) : '';
        if (empty($tags)) {
            $tags = implode(',', array_slice($defaultTags, $defaultTagIndex, 10));
            $defaultTagIndex += 10;
        }

        // Parse system_last_live as a timestamp
        $lastLive = strtotime($m['system_last_live']);
        $isLive = ($lastLive !== false && (time() - $lastLive) <= 300); // 300 seconds = 5 minutes

        $models[] = [
            'site'                   => 'mf',
            'nickname'               => $m['name'],
            'name'                   => $m['name'],
            'imageUrl'               => $m['profile_image_full_proxy_url'],
            'viewers'                => 0,
            'followers'              => 0,
            'age'                    => $m['age'],
            'birthday'               => '',
            'languages'              => '',
            'location'               => '',
            'body'                   => $m['body_type'],
            'tags'                   => $tags,
            'subject'                => $m['room_subject'],
            'earnedForGoal'          => 0,
            'neededForGoal'          => 0,
            'broadcastVR'            => 0,
            'gender'                 => str_replace(
                                        ['c', 'f', 'm', 't', 's', 'tf', 'tm', 'tn'],
                                        ['c', 'f', 'm', 't', 't', 't',  't',  't'],
                                        (string)$m['gender']
                                    ),
            'hd'                     => 0,
            'status'                 => $isLive ? 'f' : 'offline'
        ];
    }

    return $models;
}