#!/usr/bin/bash

# this assumes [mysql] is at the top of the config

hostname=$(grep hostname config.ini | awk -F= '{ print $2 }' | sed 's/ //g' | head -1)
username=$(grep username config.ini | awk -F= '{ print $2 }' | sed 's/ //g' | head -1)
password=$(grep password config.ini | awk -F= '{ print $2 }' | sed 's/ //g' | head -1)
database=$(grep database config.ini | awk -F= '{ print $2 }' | sed 's/ //g' | head -1)

echo | mysql -h $hostname -u $username -p$password $database

if [[ $? != 0 ]];
then
	date=$(date)
	echo "$date restarting mysql"
	/etc/init.d/mysql restart
fi
