<?
include("bootstrap.php");



$module = isset($argv[1]) ? $argv[1] : "";
$ext = "";
$ext = isset($argv[1]) ? '.' . $argv[1] : '';
$ext .= isset($argv[2]) ? '.' . $argv[2] : '';
$ext .= '.lck';

define('LOCKFILE', $_AVOS['config']['site']['cronLockFile'] . $ext);

\Avos\Database\disableCache();
\Avos\Cron\debugModule($module);

if (file_exists(LOCKFILE)) {
	$pid = (int)file_get_contents(LOCKFILE);
	
	if ($pid > 0 && posix_kill($pid, 0) == true) {
		// script still running
		exit;
	}

	/*
	if (time() - filemtime(LOCKFILE) > 7200) {
		\Avos\Cron\debug("cron lockfile is older than 60 minutes so removing");
		unlink(LOCKFILE);
	}
	else {
		if (isset($argv[2])) {
			\Avos\Cron\debugModule($argv[2]);
		}
		\Avos\Cron\debug("cron aborting as an instance is already running");
		exit;
	}
	 */
}

file_put_contents(LOCKFILE, getmypid());
#\Avos\Cron\debug("cron starting");

//
// define what sites to work with
//

$sites = array();

foreach (array('BongaCams', 'Chaturbate', 'Flirt4Free', 'LiveJasmin', 'SoulCams', 'StripChat', 'Streamray', 'Streamate', 'CamSoda', 'Cherry', 'ImLive', 'xCams', 'Cam4', 'xLove', 'MyFreeCams', 'Amateur', 'FlirtBack') as $s) {
	if (isset($_AVOS['config']['webcams'][$s])) {
		$sites[] = $s;
		require(LIB . "Sites/" . $s . ".php"); 
		#\Avos\Cron\debug("configured [$s]");
	}
}

// 
// command line
//

if ($argc > 1) {

	//system($_AVOS['config']['tools']['touch'] . ' ' . LOCKFILE);

	$start = time();

	switch ($argv[1]) {

		//
		// iterate round each site updating models status
		//

		case 'status':

			if (DB_NAME != DB_CAMS) {
				\Avos\Cron\debug("unable to run on satellite site");
			}
			else {
				if (isset($argv[2])) {
					\Avos\Cron\debugModule($argv[2]);
					\Avos\Cron\online_status_update($argv[2]);
				}
				else {
					foreach ($sites as $site) {
						\Avos\Cron\debugModule($site);
						\Avos\Cron\online_status_update($site);
					}

					\Avos\Cron\debugModule($module);
				}
			}

			break;

		case 'scrape':

			if (DB_NAME != DB_CAMS) {
				\Avos\Cron\debug("unable to run on satellite site");
            }
            else {
                $num = !empty($argv[2]) ? $argv[2] : 200;
                $min = !empty($argv[3]) ? $argv[3] : 15;
                $max = !empty($argv[4]) ? $argv[4] : 30;
                \Sites\Chaturbate\scrape_models($num, $min, $max);
                \Sites\CamSoda\scrape_models($num, $min, $max);
            }

            break;


			case 'scrapeapi':
				if (DB_NAME != DB_CAMS) {
					\Avos\Cron\debug("unable to run on satellite site");
				} else {
					// Add the debug module statement before or after running the Chaturbate cron
					\Avos\Cron\debugModule($module);
					\Sites\Chaturbate\runChaturbateDataUpdateCron();
				}
				break; 
			




		//
		// download photos
		//

		case 'photos':
			foreach ($sites as $site) {
				\Avos\Cron\debugModule($site);
				$site_short = call_user_func('\\Sites\\' . $site . '\\get_shortname');
				\Avos\Cron\download_photos($site, $site_short);
			}
            \Avos\Cron\debugModule('photos');
			break;



		//
        // popular page
        //

        case 'popular':
            \Avos\Cron\cache_popular();
            break;




			
		//
        // photos_site
        //
			case 'photos_site':
				// Check if we are on the correct database
				if (DB_NAME != DB_CAMS) {
					\Avos\Cron\debug("unable to run on satellite site");
				} else {
					// Convert the site names in the $sites array to lowercase
					$sites_lowercase = array_map('strtolower', $sites);
			
					// Check if a specific site name is provided in the command line arguments
					if (isset($argv[2])) {
						$specific_site = strtolower($argv[2]); // Convert the user-provided site name to lowercase
						
						// Ensure the site is valid
						if (in_array($specific_site, $sites_lowercase)) {
							// Find the original site name in the $sites array
							$site_index = array_search($specific_site, $sites_lowercase);
							$site = $sites[$site_index]; // Get the original site name
			
							\Avos\Cron\debugModule($site);
							$site_short = call_user_func('\\Sites\\' . $site . '\\get_shortname');
							\Avos\Cron\download_photos($site, $site_short);
						} else {
							// Handle invalid site name
							\Avos\Cron\debug("Error: The specified site '$specific_site' is not recognized.");
						}
					} else {
						// If no specific site is provided, iterate over all sites
						foreach ($sites as $site) {
							\Avos\Cron\debugModule($site);
							$site_short = call_user_func('\\Sites\\' . $site . '\\get_shortname');
							\Avos\Cron\download_photos($site, $site_short);
						}
						\Avos\Cron\debugModule('photos');
					}
				}
				break;
			


		//
		// process status updates to the daily and monthly tables and archive models
		//

		case 'stats':
			\Avos\Cron\debugModule($module);
			if (DB_NAME != DB_CAMS) {
				\Avos\Cron\debug("unable to run on satellite site");
			}
			else {
				\Avos\Cron\process_history();
				\Avos\Cron\archive_models();
			}
			break;

		//
		// move models to webcamsArchive table if not recently online
		//

		case 'logs':
			\Avos\Cron\trimLogs();
			break;
			
		//
		// purge stats or move to sqlite
		//

		case 'purge':
			if (DB_NAME != DB_CAMS) {
				\Avos\Cron\debug("unable to run on satellite site");
			}
			else {
				\Avos\Cron\purge();
			}
			break;

		case 'purgemonthly':
			if (DB_NAME != DB_CAMS) {
				\Avos\Cron\debug("unable to run on satellite site");
			}
			else {
				\Avos\Cron\purge('monthly');
			}
			break;

		case 'purgehistory':
			if (DB_NAME != DB_CAMS) {
				\Avos\Cron\debug("unable to run on satellite site");
			}
			else {
				\Avos\Cron\purgeHistory();
			}
			break;

		//
		// transcode or publish videos and photos
		//

		case 'import':
		case 'publish':
		case 'actions':
			\Avos\Photos\cron($argv[1]);
			\Avos\Videos\cron($argv[1]);
			\Avos\Cron\debugModule($argv[1]);
			break;

		//
		// sync photos to a cdn
		//

		case 'cdnsync':
			\Avos\Cron\cdnSync();
			break;

		//
		// cache models to categories
		//

		case 'categories':
			\Avos\Cron\refreshCategories();
			break;

		//
		// cache all tags used by the webcams sites for the admin
		//

		case 'tags':
			\Avos\Cron\refreshSiteTags();
			break;

		//
		// cache videos to tags
		//

		case 'videostags':
			\Avos\Cron\refreshVideosTags();
			break;

		//
		// refresh sitemaps
		//

		case 'sitemaps':
			\Avos\Cron\refreshSitemap();
			break;

		//
		// backups
		//

		case 'backups':
			$now = isset($argv[2]) && $argv[2] == 'now' ? true : false;
			\Avos\Cron\backups($now);
			break;

		//
		// users notifications
		//

		case 'users':
			\Avos\Users\cron();
			break;


			case 'update_robots':
			// Load the configuration
$config = parse_ini_file('config.ini', true);

// Determine the website to update (e.g., 'site1' or 'site2')
$websiteToUpdate = $_AVOS['config']['site']['url']; // You can dynamically change this based on your needs

// Get the path to the robots.txt file for the selected website
$robotsTxtPath =  $_AVOS['config']['site']['robots_txt_path'];

// Generate the content for robots.txt (as you did before)
$siteName = $_AVOS['config']['site']['site_update_robots'];
$robotsTxt = "User-agent: *\n";
$robotsTxt .= "Disallow:\n";
$robotsTxt .= "Allow:\n";
$robotsTxt .= "Sitemap: https://www.$siteName/sitemap.xml\n";

// Save or serve $robotsTxt as your robots.txt file content
file_put_contents($robotsTxtPath, $robotsTxt);

\Avos\Cron\debug("robots.txt has been updated for $websiteToUpdate.");

				
				break;
			


			

	}

    $elapsed = time() - $start;

    if ($elapsed > 0) {
        \Avos\Cron\debug("cron completed in $elapsed seconds\n");
    }
}
else {
	usage();
	exit;
}

function usage()
{
global $argv;

print "
$argv[0] [backups|logs|cdnsync|status|stats|tags|purge|purgemonthly|import|actions|publish|categories|sitemaps|update_robots|photos|photos_site]


Available Commands:


System Extra Cron:
  sitemaps            - Add sitemaps for websites
  update_robots       - Update the robots.txt (run on new website set)

Webcams:
  status               - Update models' status via feeds
  scrape               - Scrape extra data from HTML pages (chaturbate) Args: <num models> <min delay secs> <max delay secs>
  categories           - Cache data based on defined categories/tags
  stats                - Process models' stats information
  tags                 - Create a list of tags used by models, available in the admin
  purge                - Trim daily models' stats data and optionally move from Redis to the SQLite data store
  purgemonthly         - Move monthly models' data from Redis to the SQLite data store

Videos and Photos:
  import               - Import and process new videos and zips of photo galleries from avos/incoming/
  actions              - Rename/delete files/folders as needed from admin actions
  publish              - Publish videos and photo galleries

System:
  backups              - Backup data to avos/backups/ folder
  logs                 - Trim size of avos/logs/ files
  cdnsync              - Sync any files to a CDN



";


 



}

unlink(LOCKFILE);
