<?
include('bootstrap.php');

\Avos\Database\disableCache();

//
// command line
//

if ($argc > 1) {

	switch ($argv[1]) {

		//
		// output redis sql cache
		//

		case 'cache':

			$keys = $redis->keys("sql/*");
			foreach ($keys as $k) {
				echo "$k\n";
			}

			break;

		//
		// output all redis keys
		//

		case 'keys':

			$search = isset($argv[2]) ? $argv[2] : '*';
			$keys = $redis->keys($search);
			#echo "found " . count($keys) . " keys\n";
			foreach ($keys as $k) {
				echo "$k\n";
			}

			break;


		//
		// delete rdis elements by keys
		//

		case 'rmkeys':

			$search = isset($argv[2]) ? $argv[2] : '*';
			$keys = $redis->keys($search);
			echo "deleting " . count($keys) . " keys\n";
			foreach ($keys as $k) {
				echo "deleting $k\n";
				$redis->del($k);
			}

			break;

		//
		// output a redis element
		//

		case 'get':

			#echo "get=$argv[2]\n";
			$type = $redis->type($argv[2]);

            switch ($type) {
                case Redis::REDIS_NOT_FOUND:
                    echo "not found\n";
                    break;

				case Redis::REDIS_STRING:
					echo "type:$type Redis::REDIS_STRING\n";
					$val = $redis->get($argv[2]);
					// could be an unserialised array
					if (is_array($val)) {
						print_r($val);
					}
					else {
						echo "$val\n";
					}
					break;

				case Redis::REDIS_LIST:
					echo "type:$type Redis::REDIS_LIST\n";
					$val = $redis->lRange($argv[2], 0, -1);
					print_r($val);
					break;

				case Redis::REDIS_HASH:
					echo "type:$type Redis::REDIS_HASH\n";
					$val = $redis->hGetAll($argv[2]);
					print_r($val);
					break;
			}
	}
}
else {
	echo "$argv[0] [cache|keys|rmkeys|get]\n";
	exit;
}


