<?php

namespace Sites\Cam4;

function get_shortname()
{
    return 'c4';
}

function online_status()
{
    global $_AVOS;

    $url = 'https://api.pinklabel.com/api/v1/cams/online.xml?aff_id=' . $_AVOS['config']['webcams']['Cam4']['api_key'] . '&prog=rs&limit=5550&order_by=viewers_desc';

//https://api.pinklabel.com/api/v1/cams/online.xml?aff_id=6e85b91f669292b79bfb9d6300218bb6&prog=rs&limit=5550&order_by=viewers_desc



    $raw = @file_get_contents($url);
    $xml = simplexml_load_string($raw);
    $models = array();
 

 if (!isset($xml->object)) {
        if (isset($xml->description)) {
            echo "ERR: " . (string)$xml->description . "\n";
        }
        return $models;
    } 
    


    // gender: c, f, m, s
    // only add model if female or couple or have more than 5 viewers

    foreach ($xml->object as $m) {
        // Check if the model has viewers
        $viewers = (int)$m->viewers;
        if ($viewers > 5) {
            // Model is online
            $online_status = 'f';
        } else {
            // Model is offline
            $online_status = 'o';
            continue; // Skip this model if offline
        }
    
        // Continue fetching other details
    
        $languages = array();
        foreach ($m->languages->language as $language) {
            $languages[] = (string)$language;
        }
    
        $tags = array();
        foreach ($m->{'show-tags'}->{'show-tag'} as $tag) {
            $tags[] = (string)$tag;
        }
    
        $age = (int)$m->age;
        if ($age <= 0 || $age == 99) {
            $age = 32;
        }
    
        $models[] = array(
            'site'           => 'c4',
            'nickname'       => (string)$m->nickname,
            'name'           => (string)$m->nickname,
            'imageUrl'       => (string)$m->thumb,
            'viewers'        => $viewers,
            'age'            => $age,
            'earnedForGoal'  => 0, // Replace with actual value if available
            'neededForGoal'  => 0, // Replace with actual value if available
            'broadcastVR'    => 0, // Replace with actual value if available
            'languages'      => implode(',', $languages),
            'location'       => (string)$m->country,
            'tags'           => implode(',', $tags),
            'subject'        => (string)$m->status,
            'gender'         => str_replace(
                array('couple', 'female', 'male', 'trans', 'shem', 'unknown' ),
                array('c', 'f', 'm', 't', 't', 't'),
                (string)$m->gender
            ),
            'status'         => $online_status, // Set online or offline status
        );
    }
    
    print_r($models);
    

    return $models;

}

