<?
namespace Sites\Streamate;

//
// field names:
//
// Name, Id, About, Age, Audio, BodyHair, Build, Circumcised, Ethnicity, Expertise, 
// EyeColor, FacialHair, Fetishes, Gender, HairColor, Height, BodyMods, Language, Bust, 
// CupSize, Waist, Hips, CockSize, Phone, PubicHair, SexPref, TurnOns, Theme, Weight, Zodiac
//

function get_shortname()
{
	return 'sm';
}

function online_status()
{
	$url = 'http://affiliate.streamate.com/SMLive/SMLResult.xml';

	//----------------------------------------------------------------------------------
	// the xml request structure
	//
	
	$request = <<<REQUEST
<?xml version="1.0" encoding="UTF-8"?>
<SMLQuery>
  <Options MaxResults="1000" />
  <AvailablePerformers>
    <Include>
      <Descriptions />
      <Media>biopic,photogallery</Media>
      <FreeChatSort />
    </Include>
    <Constraints>
      <StreamType>live</StreamType>
    </Constraints>
  </AvailablePerformers>
</SMLQuery>
REQUEST;

$curl = curl_init();
curl_setopt($curl, CURLOPT_URL, $url);
curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
curl_setopt($curl, CURLOPT_HTTPHEADER, array('Content-Type: text/xml'));
curl_setopt($curl, CURLOPT_POST, 1);
curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 5);
curl_setopt($curl, CURLOPT_TIMEOUT, 10);
curl_setopt($curl, CURLOPT_POSTFIELDS, $request);
	$response = curl_exec($curl);





	
	#echo "streamate: response size is [" . strlen($response) . "]\n";
	$xml = simplexml_load_string(utf8_encode($response), 'SimpleXMLElement', LIBXML_NOCDATA);
	
	$models = array();
	
	foreach ($xml->AvailablePerformers->Performer as $performer)
    {
		$model = array();
		$photos = array();
	
		foreach ($performer->attributes() as $key => $val)
		{
			$model[$key] = (string)$val;
		}
	
		foreach (array('About', 'Expertise', 'TurnOns') as $key)
		{
			if (isset($performer->Descriptions->$key))
			{
				$model[$key] = (string)$performer->Descriptions->$key;
			}
		}

		if (isset($performer->Media) && isset($performer->Media->Pic) && isset($performer->Media->Pic->Full))
		{
			$model['imageUrl'] = 'http:' . (string)$performer->Media->Pic->Full->attributes()->Src;
		}
	
		if (isset($performer->Media) && isset($performer->Media->PhotoGallery) && isset($performer->Media->PhotoGallery->Pic))
		{
			foreach ($performer->Media->PhotoGallery->Pic as $pic)
			{
				$photos[] = 'http:' . (string)$pic->Full->attributes()->Src;
			}

			$model['photos'] = $photos;
		}

		// only one hair color is wrong
		if (isset($model['HairColor']) && $model['HairColor'] == 'blond') $model['HairColor'] = 'blonde';

		// bi needs to be bisexual
		if (isset($model['SexPref']) && $model['SexPref'] == 'bi') $model['SexPref'] = 'bisexual';

		// normalise the cupsize
		if (isset($model['CupSize']) && preg_match('/(\w+)/', $model['CupSize'], $cap))
		{
			if ($cap[1] == 'g' || $cap[1] == 'h' || $cap[1] == 'i' || $cap[1] == 'j' || $cap[1] == 'k' || $cap[1] == 'k+')
			{
				$model['CupSize'] = 'HUGE';
			}
			else {
				$model['CupSize'] = strtoupper($cap[1]);
			}
		}

		// sometimes contains 2 vals - maybe for 2 models?
		foreach (array('Build', 'HairColor', 'HairLength', 'EyeColor') as $a)
		{
			if (isset($model[$a]))
			{
				if (preg_match('/(\w+),/', $model[$a], $cap)) $model[$a] = $cap[1];
			}
		}

		// language is an array
        if (isset($model['Language'])) {
            $model['Language'] = explode(',', $model['Language']);
        }
        else {
            $model['Language'] = [];
        }

		//
		// now create our models data
		//

		$m = array(
			'site' => 'sm',
			'externalId' => $model['Id'],
			'nickname' => $model['Name'],
			'name' => $model['Name'],
			'earnedForGoal' => 0, // Replace with actual value if available
			'neededForGoal' => 0, // Replace with actual value if available
			'broadcastVR' => 0 ,// Replace with actual value if available
			'gender' => strlen($model['Gender']) > 1 ? 'c' : $model['Gender'],
			'age' => isset($model['Age']) ? $model['Age'] : 0,
			'build' => isset($model['Build']) ? $model['Build'] : '',
			'hair' => isset($model['HairColor']) ? $model['HairColor'] : '',
			'eyes' => isset($model['EyeColor']) ? $model['EyeColor'] : '',
			'ethnicity' => isset($model['Ethnicity']) ? $model['Ethnicity'] : '',
			'subject' => isset($model['About']) ? $model['About'] : '',
			'tags' => isset($model['Fetishes']) ? $model['Fetishes'] : '',
			'status' => ($model['PartyChat'] == 1 || $model['GoldShow'] == 1) ? 'f' : 'f',
			#'imageUrl' => "https://object-cdn.icfsys.com/smconnect-snapshots/320x240/$model[Id].jpg",
			'imageUrl' => $model['imageUrl'],
			'photos' => $photos
		);

		if (!empty($model['Build'])) {
			if (!empty($m['tags'])) {
				$m['tags'] .= ',';
			}
			$m['tags'] .= $model['Build'];
		}

		if (!empty($model['Theme'])) {
			if (!empty($m['tags'])) {
				$m['tags'] .= ',';
			}
			$m['tags'] .= $model['Theme'];
		}

		if (!empty($model['BodyMods'])) {
			if (!empty($m['tags'])) {
				$m['tags'] .= ',';
			}
			$m['tags'] .= $model['BodyMods'];
		}

		// append model
		$models[] = $m;
	}

	return $models;
}

